' $Horde: HordeConduit/HordeSync/CNotify.vb,v 1.1.1.1 2003/03/05 05:12:25 marcus Exp $

Imports PDDirectLib
Imports PDStandardLib
Public Class CNotify
    Implements IPDClientNotify

    Private Conduits As New Hashtable()

    Overridable Overloads Function _
     GetConduitInfo(ByVal infoType As EGetConduitInfo, _
                    ByVal nCreatorId As Integer, _
                    ByVal nUserId As Integer, _
                    ByVal sUserName As String) As Object _
     Implements IPDClientNotify.GetConduitInfo

        Dim sCreatorId As String, palmCondMgr As New PDCondMgr()
        sCreatorId = palmCondMgr.CreatorIDToString(nCreatorId)

        If Not Conduits.ContainsKey(sCreatorId) Then
            AddConduit(sCreatorId)
            If Not Conduits.ContainsKey(sCreatorId) Then
                Throw New SystemException("Could not locate or create a conduit for " & sCreatorId)
            End If
        End If

        Select Case infoType
            Case EGetConduitInfo.eGetConduitName
                Return Conduits(sCreatorId).Name
            Case EGetConduitInfo.eGetConduitVersion
                Return Conduits(sCreatorId).Version
            Case EGetConduitInfo.eGetDefaultAction
                Return Conduits(sCreatorId).DefaultAction
            Case EGetConduitInfo.eGetMfcVersion
                Return Conduits(sCreatorId).MfcVersion
        End Select

    End Function
    Overridable Overloads Sub CfgConduit(ByVal nCreatorId As Integer, _
                                         ByVal nUserId As Integer, _
                                         ByVal sUserName As String, _
                                         ByVal sPathName As String, _
                                         ByRef nSyncPerm As Integer, _
                                         ByRef nSyncTemp As Integer, _
                                         ByRef nSyncNew As Integer, _
                                         ByRef nSyncPref As Integer) _
     Implements IPDClientNotify.CfgConduit

        Dim sCreatorId As String, palmCondMgr As New PDCondMgr()
        sCreatorId = palmCondMgr.CreatorIDToString(nCreatorId)

        If Not Conduits.ContainsKey(sCreatorId) Then
            AddConduit(sCreatorId)
            If Not Conduits.ContainsKey(sCreatorId) Then
                Throw New SystemException("Could not locate or create a conduit for " & sCreatorId)
            End If
        End If

        Conduits(sCreatorId).CfgConduit(nUserId, sUserName, sPathName, nSyncPerm, nSyncTemp, nSyncNew, nSyncPref)
    End Sub
    Overridable Overloads Sub ConfigureConduit(ByVal sPathName As String, _
                                               ByVal sRegistry As String, _
                                               ByRef nSyncPref As Integer, _
                                               ByRef nSyncType As Integer) _
     Implements IPDClientNotify.ConfigureConduit
        MsgBox("WARNING: You are running an older version of HotSync than we fully support." & _
               vbCrLf & "We only support the standar synchronization on this platform." & _
               vbCrLf & "Please update HotSync and the Palm Desktop.")

        nSyncType = ESyncTypes.eFast
        nSyncPref = ESyncPref.ePermanentPreference
    End Sub
    Overridable Overloads Function BeginProcess() As Boolean _
     Implements IPDClientNotify.BeginProcess

        'If we're not in a HotSync, do nothing
        Dim palmHotSyncUtil As New PDHotSyncUtility()
        If Not palmHotSyncUtil.IsSyncInProgress Then
            Return False
        End If

        'We'll need these to figure out which conduit to call
        Dim palmSys As New PDSystemAdapter()
        Dim palmHSI As PDHotsyncInfo = palmSys.PDHotsyncInfo()
        Dim palmUtil As New PDUtility()
        Dim palmCondMgr As New PDCondMgr()

        'Get the creatorId and make sure we have a conduit installed for it
        Dim sCreatorId As String = palmCondMgr.CreatorIDToString(palmHSI.Creator)
        If Not Conduits.ContainsKey(sCreatorId) Then
            AddConduit(sCreatorId)
            If Not Conduits.ContainsKey(sCreatorId) Then
                Throw New SystemException("Could not locate or create a conduit for " & sCreatorId)
            End If
        End If

        'Assuming we do have a conduit, run its BeginProcess() method
        If Conduits.ContainsKey(sCreatorId) Then
            Console.Write(sCreatorId & " Returned " & Conduits(sCreatorId).BeginProcess())
        End If

        ' Return false to signal completion!
        Return False

    End Function
    Private Sub AddConduit(ByVal sCreatorId As String)
        If Conduits.ContainsKey(sCreatorId) Then Return

        Dim sObjectName As String
        sObjectName = "HordeSync." & sCreatorId & "Conduit"

        'If there is no supported conduit, trip an alert and exit.
        Try
            Conduits.Add(sCreatorId, CreateObject(sObjectName))
        Catch err As System.Runtime.InteropServices.COMException
            Return
        End Try
    End Sub
End Class
