' $Horde: HordeConduit/HordeSync/todoConduit.vb,v 1.1.1.1 2003/03/05 05:12:29 marcus Exp $
Imports PDStandardLib
Imports PDDirectLib
Imports System.Text
Imports PDDirectLib.EAccessModes

<ComClass(todoConduit.ClassId, todoConduit.InterfaceId, todoConduit.EventsId)> _
Public Class todoConduit
    Inherits baseConduit
#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "F18287F6-8920-44BC-A3D5-1DCB9499D6CB"
    Public Const InterfaceId As String = "BDCF283C-A727-4D39-A685-44B80E9434CA"
    Public Const EventsId As String = "71D1EA7A-9EAA-4BC9-8D41-EC9CA8CBEF05"
#End Region

    ' A creatable COM class must have a Public Sub New() 
    ' with no parameters, otherwise, the class will not be 
    ' registered in the COM registry and cannot be created 
    ' via CreateObject.
    Public Sub New()
        MyBase.New()
        Me.sName = "Todo -> Horde Tasks"
    End Sub

    Public Overrides Function BeginProcess() As Boolean
        MyBase.BeginProcess()

        Dim palmSystem As New PDSystemAdapter()
        Dim palmHotSyncInfo As PDHotsyncInfo = palmSystem.PDHotsyncInfo

        Dim rpcTasks As Object = HSU.Connect("tasks.")

        Dim palmDB As New PDDatabaseQuery()
        Dim TodoDB As PDTodoDbHHRecordAdapter = _
            palmDB.OpenRecordDatabase("ToDoDB", "PDStandard.PDTodoDbHHRecordAdapter", _
                                      eWrite Or eRead Or eShowSecret)

        Select Case palmHotSyncInfo.SyncType
            Case ESyncTypes.eDoNothing
                'Do nothing
            Case ESyncTypes.ePCtoHH
                Try
                    Dim x As Integer = 0

                    'First we delete the database, including categories
                    If TodoDB.RecordCount > 0 Then
                        TodoDB.RemoveSet(ERemoveSetType.eRemoveAllRecords)
                    End If
                    Dim AppInfo As Object = TodoDB.ReadAppInfoBlock
                    For x = 0 To 274
                        AppInfo(x) = &H0
                    Next
                    TodoDB.WriteAppInfoBlock(AppInfo)

                    'Define a hash to hold categories and add Unfiled, plus all from default memolist
                    Dim hashCategories As New Hashtable()
                    hashCategories.Add("Unfiled", AddCategory(TodoDB.PDCategories, "Unfiled"))
                    Dim cat As Object, catList As Object = rpcTasks.listCategories
                    For Each cat In catList
                        If Not hashCategories.ContainsKey(cat) Then
                            hashCategories.Add(cat, AddCategory(TodoDB.PDCategories, cat))
                        End If
                    Next

                    'Get a list of memos, adding categories as necessary
                    Dim a As New ASCIIEncoding()
                    Dim task As Object, taskList As Object = rpcTasks.list
                    For Each task In taskList
                        Dim sKey As String = rpcTasks.formatCategory(task.category, task.tasklist_id)
                        If Not hashCategories.ContainsKey(sKey) Then
                            hashCategories.Add(sKey, Me.AddCategory(TodoDB.PDCategories, sKey))
                        End If

                        Dim t As New PDTodoDbHHRecord()
                        t.CategoryId = hashCategories(sKey)
                        t.Description = task.name
                        If task.desc <> "" Then
                            'Translate CR/LF to just CR
                            task.desc = Replace(task.desc, Chr(13), "")
                            t.Notes = task.desc
                        End If
                        If task.due <> 0 Then t.DueDate = DateAdd(DateInterval.Second, task.due, #1/1/1970#)
                        t.Priority = task.priority
                        If task.completed > 0 Then t.IsCompleted = True
                        TodoDB.Write(t)
                    Next
                    TodoDB = Nothing
                Catch err As SystemException
                    MsgBox("Error: " & err.Message & vbCrLf & err.ToString)
                    TodoDB = Nothing
                End Try
            Case ESyncTypes.eHHtoPC
                MsgBox("Tasklist does not support Handheld overwrites Horde yet.")
            Case Else
                MsgBox("Tasklist does not support Handheld to Horde Syncing yet.")
        End Select

        Return False
    End Function
End Class
